<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->


<!-- The `aria-labelledby` does not have a label available, we go for the simple label -->
<!-- eslint-disable-next-line -->
<table
  [summary]="currentFolderViewBlock | folderViewBlockName"
  class="table table-sm table-striped table-borderless border bg-white shadow-sm">
  <thead class="border">
    <tr>
      <th scope="col" class="icon-column">
        <fa-icon
          class="pointer text-primary"
          [icon]="isCollapsed ? plusSquareIcon : minusSquareIcon"
          (click)="isCollapsed = !isCollapsed"
          [fixedWidth]="true">
        </fa-icon>
      </th>
      <th
        scope="colgroup"
        colspan="2"
        [innerText]="currentFolderViewBlock | folderViewBlockName">
      </th>
      <th scope="col" class="col-actions-fixed-size text-end">
        <label
          [ngClass]="{'opacity-0 cursor-default' : !isEditable || !canAddDocument}"
          for="addDocumentFileInput{{ displayMainDocuments ? 'main' : '' }}"
          class="p-0 m-0 text-primary pointer">
          <fa-icon [icon]="commonIcons.ADD_ICON"></fa-icon>
        </label>
        <input
          id="addDocumentFileInput{{ displayMainDocuments ? 'main' : '' }}"
          type="file"
          [disabled]="!isEditable || !canAddDocument"
          [accept]="selectableMediaTypes.join(' ')"
          (change)="addDocument($event)"
          hidden>
      </th>
    </tr>
  </thead>
  <tbody [ngClass]="isCollapsed === true ? 'collapse' : ''">
    <tr *ngIf="show52Features && isSignatureReport && serverInfo.signatureValidationServiceActivated && getSignatureProofErrorFn(folder) !== null">
      <td class="icon-column">
        <fa-icon
          class="text-warning ms-1"
          [icon]="commonIcons.WARNING_ICON"
          [fixedWidth]="true">
        </fa-icon>
      </td>
      <td
        class="text-warning text-wrap custom-font-size"
        colSpan="2"
        [innerHTML]="getSignatureProofErrorFn(folder)">
      </td>
      <td>
        <button
          class="btn px-1 text-warning"
          type="button"
          id="generateSignatureProof"
          (click)="generateDocumentSignatureVerification()">
          <fa-icon
            [ngbTooltip]="messages.GENERATE_SIGNATURE_VALIDATION"
            [icon]="commonIcons.RE_INIT_ICON"
            [fixedWidth]="true">
          </fa-icon>
        </button>
      </td>
    </tr>
    <tr
      *ngFor="let document of getDocumentList()"
      class="clickable-row show-icons-on-hover"
      [ngClass]="{'table-primary' : document === currentDocument}"
      (click)="onRowClicked(document)">

      <td class="icon-column">
        <fa-icon
          class="text-primary ms-1"
          *ngIf="document.mediaType | documentIcon"
          [icon]="document.mediaType | documentIcon"
          [fixedWidth]="true">
        </fa-icon>
      </td>

      <td
        class="overflow-hidden text-truncate"
        [ngClass]="{
          'col-name-reduced': userPreferences?.showAdminIds,
          'col-name': !userPreferences?.showAdminIds
        }"
        [colSpan]="userPreferences?.showAdminIds ? '1' : '2'">
        <span [innerText]="document.name | namePipe" [ngbTooltip]="document.name | namePipe" openDelay="300"></span>
      </td>

      <td
        *ngIf="userPreferences?.showAdminIds ?? false"
        class="col-id-unsortable-fixed-size">
        <span
          class="font-monospace text-size-small"
          [innerText]="document.id">
        </span>
      </td>

      <td>

        <span
          *ngIf="displayMainDocuments"
          [ngClass]="{
              'invisible' : !(displayMainDocuments && (doesTypologyAllowDetachedSignatureAdding || doesContainSignatureFn(document))),
              'opacity-50': !doesContainSignatureFn(document)
          }"
          ngbDropdown
          container="body"
          #signaturesDrop="ngbDropdown"
          [ngbTooltip]="messages.SIGNATURES">

          <button
            class="btn px-1"
            type="button"
            id="signaturesDropdownManual"
            ngbDropdownAnchor
            (focus)="signaturesDrop.open()">
            <fa-icon
              [class]="document | areAllSignaturesValid:serverInfo.signatureValidationServiceActivated | signatureStatusColor"
              [icon]="document | areAllSignaturesValid:serverInfo.signatureValidationServiceActivated | signatureStatusIcon"
              [fixedWidth]="true">
            </fa-icon>
          </button>

          <div
            ngbDropdownMenu
            aria-labelledby="signaturesDropdownManual"
            class="p-1 border custom-popup">

            <div class="p-3 border bg-light">

              <ng-container *ngFor="let signatureType of Object.keys(getSignatureInfo(document))">

                <!-- No need for a label in some cases -->
                <div *ngIf="getSignatureInfo(document)[signatureType].length > 0 && show52Features && containsInternalSignatureProof()">
                  <div>
                    <label
                      id="{{ 'signatureType' + signatureType + 'label' }}"
                      class="mx-3 mb-2 fw-bold"
                      [innerText]="signatureType === 'embedded' ? messages.EMBEDDED_SIGNATURES : messages.DETACHED_SIGNATURES">
                    </label>
                  </div>

                  <!-- If the folder has be started, the default action on detached signatures is a regular download -->
                  <table
                    aria-labelledby="{{ 'signatureType' + signatureType + 'label' }}"
                    class="table table-striped table-bordered">
                    <thead>
                      <tr>
                        <th></th>
                        <th class="custom-font-size" [innerText]="FolderViewMessages.SIGNATORY"></th>
                        <th class="custom-font-size" [innerText]="FolderViewMessages.SIGNATURE_DATE"></th>
                        <th class="custom-font-size" [innerText]="FolderViewMessages.CERTIFICATE_VALIDITY"></th>
                        <th class="custom-font-size" [innerText]="FolderViewMessages.EIDAS_LEVEL"></th>
                        <th class="custom-font-size" [innerText]="FolderViewMessages.ERROR"></th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr *ngFor="let signatureInfo of getSignatureInfo(document)[signatureType]">
                        <td>
                          <fa-icon
                            class="me-2 {{ isSignatureValidAndNotNull(signatureInfo) | signatureStatusColor }}"
                            [icon]="isSignatureValidAndNotNull(signatureInfo) | signatureStatusIcon"
                            [fixedWidth]="true">
                          </fa-icon>
                        </td>
                        <td>
                          <span>
                            <div
                              *ngIf="signatureInfo.signatory"
                              class="custom-font-size"
                              [innerText]="signatureInfo.signatory">
                            </div>
                          </span>
                          <span>
                            <div
                              *ngIf="signatureInfo.certificate"
                              class="text-secondary custom-font-size"
                              [innerText]="signatureInfo.certificate">
                            </div>
                          </span>
                        </td>
                        <td>
                          <span
                            *ngIf="signatureInfo.signatureDateTime"
                            class="custom-font-size"
                            [innerText]="timestampToDateFn(signatureInfo.signatureDateTime) | date: 'medium'">
                          </span>
                          <span
                            *ngIf="!signatureInfo.signatureDateTime"
                            class="text-secondary text-break custom-font-size"
                            [innerText]="messages.CANNOT_READ_THE_SIGNATURE_DATE">
                          </span>
                        </td>
                        <td>
                          <span>
                            <div
                              *ngIf="signatureInfo.certificateBeginDate"
                              class="custom-font-size text-center"
                              [innerText]="messages.SIGNATURE_CERTIFICATION_DATE_FROM + (timestampToDateFn(signatureInfo.certificateBeginDate) | date: 'mediumDate')">
                            </div>
                          </span>
                          <span>
                            <div
                              *ngIf="signatureInfo.certificateEndDate"
                              class="custom-font-size text-center"
                              [innerText]="messages.SIGNATURE_CERTIFICATION_DATE_TO + (timestampToDateFn(signatureInfo.certificateEndDate) | date: 'mediumDate')">
                            </div>
                          </span>
                        </td>
                        <td>
                          <span
                            *ngIf="signatureInfo.eidasLevel"
                            class="custom-font-size text-center"
                            [innerText]="signatureInfo.eidasLevel">
                          </span>
                        </td>
                        <td>
                          <span
                            *ngIf="signatureInfo.error"
                            class="custom-font-size"
                            [innerText]="signatureInfo.error">
                          </span>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>

              </ng-container>

              <ng-container *ngIf="doesContainEmbeddedSignatureFn(document) && (!show52Features || (show52Features && !containsInternalSignatureProof()))">

                <!-- No need for a label in some cases -->
                <div>
                  <label
                    class="mx-3 mb-2 fw-bold"
                    [innerText]="messages.EMBEDDED_SIGNATURES">
                  </label>
                </div>

                <!-- If the folder has be started, the default action on detached signatures is a regular download -->
                <div
                  *ngFor="let embeddedSignatureInfo of document.embeddedSignatureInfos"
                  class="mx-3 mb-2">
                  <fa-icon
                    class="me-2 {{ embeddedSignatureInfo.isSignatureValid | signatureStatusColor }}"
                    [icon]="embeddedSignatureInfo.isSignatureValid | signatureStatusIcon"
                    [fixedWidth]="true">
                  </fa-icon>
                  <span
                    *ngIf="embeddedSignatureInfo.signatureDateTime"
                    [innerText]="timestampToDateFn(embeddedSignatureInfo.signatureDateTime) | date: 'medium'">
                  </span>
                  <span
                    *ngIf="!embeddedSignatureInfo.signatureDateTime"
                    class="text-secondary"
                    [innerText]="messages.CANNOT_READ_THE_SIGNATURE_DATE">
                  </span>
                </div>

              </ng-container>

              <ng-container *ngIf="doesTypologyAllowDetachedSignatureAdding || doesContainDetachedSignatureFn(document)">

                <!-- No need for a label in some cases -->
                <label
                  class="mx-3 my-1 fw-bold"
                  *ngIf="((!isInValidationWorkflowFn(folder)) || (document.detachedSignatures.length > 0)) && (!show52Features || (show52Features && !containsInternalSignatureProof()))"
                  [innerText]="messages.DETACHED_SIGNATURES">
                </label>

                <ng-container *ngIf="isInValidationWorkflowFn(folder)">
                  <!-- If the folder has be started, the default action on detached signatures is a regular download -->
                  <a
                    ngbDropdownItem
                    *ngFor="let detachedSignature of document.detachedSignatures"
                    (click)="downloadFile(document, detachedSignature)"
                    [download]="detachedSignature.name"
                    class="pointer">
                    <fa-icon
                      class="me-2 text-secondary"
                      [icon]="faDownload"
                      [fixedWidth]="true">
                    </fa-icon>
                    {{ detachedSignature?.name | namePipe }}
                  </a>
                </ng-container>

                <ng-container *ngIf="!isInValidationWorkflowFn(folder)">

                  <!-- If the folder is still a draft, the default action on detached signatures is a delete -->
                  <a
                    ngbDropdownItem
                    *ngFor="let detachedSignature of document.detachedSignatures"
                    (click)="deleteDetachedSignature($event, document.id, detachedSignature)"
                    class="pointer">
                    <fa-icon
                      class="me-2 delete-icon-secondary"
                      [icon]="commonIcons.DELETE_ICON"
                      [fixedWidth]="true">
                    </fa-icon>
                    {{ detachedSignature?.name | namePipe }}
                  </a>

                  <!-- And if the folder is still a draft, we can still add a signature -->
                  <a
                    *ngIf="!isInValidationWorkflow"
                    ngbDropdownItem
                    class="pointer">
                    <div>
                      <label
                        class="my-0 py-0"
                        for="addDetachedSignatureFileInput{{ document.id }}">
                        <fa-icon
                          class="me-2 text-secondary"
                          [icon]="commonIcons.ADD_ICON"
                          [fixedWidth]="true">
                        </fa-icon>
                        <span [innerText]="messages.ADD_DETACHED_SIGNATURE"></span>
                      </label>
                    </div>
                    <input
                      id="addDetachedSignatureFileInput{{ document.id }}"
                      type="file"
                      [accept]="mimeTypesDetachedSignature"
                      (change)="addDetachedSignature($event, document)"
                      hidden>
                  </a>

                </ng-container>

              </ng-container>

            </div>
          </div>

        </span>

        <span
          ngbDropdown
          container="body"
          #documentActionsDrop="ngbDropdown">

          <button
            class="btn"
            type="button"
            id="documentActionsDropdownManual"
            ngbDropdownAnchor
            (focus)="documentActionsDrop.open()">
            <fa-icon
              class="text-primary"
              [icon]="faEllipsisV">
            </fa-icon>
          </button>

          <div
            ngbDropdownMenu
            aria-labelledby="documentActionsDropdownManual">

            <a
              ngbDropdownItem
              *ngIf="isEditable && (!displayMainDocuments || (getDocumentList().length > 1)) && canDeleteDocument(document)"
              class="pointer"
              (click)="deleteDocument($event, document)">
              <fa-icon
                class="me-2 delete-icon-secondary"
                [title]="commonMessages.DELETE"
                [icon]="commonIcons.DELETE_ICON"
                [fixedWidth]="true">
              </fa-icon>
              <span [innerText]="messages.DELETE_DOCUMENT"></span>
            </a>

            <a
              *ngIf="isEditable && displayMainDocuments && (getDocumentList().length <= 1)"
              ngbDropdownItem
              class="pointer">
              <label
                class="my-0 py-0"
                for="replaceDocumentFileInput{{ document.id }}">
                <fa-icon
                  class="me-2 text-secondary"
                  [title]="commonMessages.REPLACE"
                  [icon]="faSyncAlt"
                  [fixedWidth]="true">
                </fa-icon>
                <span [innerText]="messages.REPLACE_DOCUMENT"></span>
              </label>
              <input
                id="replaceDocumentFileInput{{ document.id }}"
                type="file"
                [accept]="selectableMediaTypes.join(' ')"
                (change)="replaceDocument(document, $event)"
                hidden>
            </a>

            <a
              (click)="downloadFile(document)"
              [download]="document.name"
              ngbDropdownItem
              class="pointer">
              <fa-icon
                class="me-2 text-secondary"
                [icon]="faDownload"
                [fixedWidth]="true">
              </fa-icon>
              <span [innerText]="messages.DOWNLOAD_ORIGINAL_DOCUMENT"></span>
            </a>

          </div>

        </span>

        <button
          [ngClass]="{'invisible' : !canBeOpenedInPdfViewer(document)}"
          class="btn px-0"
          [ngbTooltip]="messages.DISPLAY"
          type="button">
          <fa-icon
            class="text-primary"
            [icon]="rightChevronIcon"
            [fixedWidth]="true">
          </fa-icon>
        </button>

      </td>
    </tr>
  </tbody>
  <tbody
    app-list-loader
    [data]="getDocumentList()"
    [loading]="false"
    [colspan]="colspan"
    [emptyMessage]="commonMessages.EMPTY_DOCUMENT_LIST">
  </tbody>
</table>
